<script>
import { onMount } from 'svelte';
import {json} from 'd3-fetch';
import {scaleLinear} from 'd3-scale';
import { extent } from 'd3-array';

 
  // Size and margins
  const width = 600;
  const height = 250;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  let datapoints=[];
  onMount(async () => {
    datapoints = await json("/data/daily_heating_cooling.json")
  });

  let data_heating={};
  $: datapoints.forEach((d) => {
    if(!(d.city in data_heating)){
      data_heating[d.city]=[]
    }
    data_heating[d.city].push(d.heating)
  });

  let data_cooling={};
  $: datapoints.forEach((d) => {
    if(!(d.city in data_cooling)){
      data_cooling[d.city]=[]
    }
    data_cooling[d.city].push(d.cooling)
  });
  $: console.log(data_heating);
  //$: console.log(data_cooling);

  let cx=100;
  let cy=100;
  let r=50;
  let start_degree=0;
  let stop_degree=1;

 $: scaleH = scaleLinear().domain(extent(datapoints.map((d) => d.heating))).range([0, 75]);

 $: scaleC = scaleLinear().domain(extent(datapoints.map((d) => d.cooling))).range([0, 75]);

 let scaleD = scaleLinear().domain([0, 365]).range([360, 0]);

  const d2radians = function(degree) {
    return Math.PI*(degree)/180
  }

  const x = function(cx, radius, theta) {
    return Number(cx) + radius*Math.cos(theta)
  }

  const y = function(cy, radius, theta) {
    return Number(cy) + radius*Math.sin(theta)
  }

  const Circle = function(cx, cy, r, start_degree, stop_degree) {
    let start_theta = d2radians(start_degree)
    let stop_theta = d2radians(stop_degree)
    let start_x = x(cx, r, start_theta)
    let start_y = y(cy, r, start_theta)
    let stop_x = x(cy, r, stop_theta)
    let stop_y = y(cx, r, stop_theta)
    return "M " + cx + " " + cy + " "+
           "L " + start_x + " " + start_y + " " +
           "A " + r + " " + r + " 0 0 1 " + stop_x + " " + stop_y + " " + 
           "Z"
  }
</script>

<svg {width} {height}>
  <g transform="translate({margin.left}, {margin.top})">
    <!--  -->
    <circle cx=100 cy=100 r=80 fill="none" stroke="black"/>
    <circle cx=300 cy=100 r=80 fill="none" stroke="black"/>
    <circle cx=500 cy=100 r=80 fill="none" stroke="black"/>
    <line x1=100 x2=100 y1=20 y2=180 />
    <line x1=300 x2=300 y1=20 y2=180 />
    <line x1=500 x2=500 y1=20 y2=180 />
    <line x1=20 x2=180 y1=100 y2=100 />
    <line x1=220 x2=380 y1=100 y2=100 />
    <line x1=420 x2=580 y1=100 y2=100 />
    <text x=100 y=220 text-anchor="middle">Chicago</text>
    <text x=300 y=220 text-anchor="middle">Baltimore</text>
    <text x=500 y=220 text-anchor="middle">Los Angeles</text>
    <text x=100 y=15 text-anchor="middle">0</text>
    <text x=300 y=15 text-anchor="middle">0</text>
    <text x=500 y=15 text-anchor="middle">0</text>
    <text x=100 y=195 text-anchor="middle">6</text>
    <text x=300 y=195 text-anchor="middle">6</text>
    <text x=500 y=195 text-anchor="middle">6</text>
    <text x=12 y=105 text-anchor="middle">9</text>
    <text x=188 y=105 text-anchor="middle">3</text>
    <text x=212 y=105 text-anchor="middle">9</text>
    <text x=388 y=105 text-anchor="middle">3</text>
    <text x=412 y=105 text-anchor="middle">9</text>
    <text x=585 y=105 text-anchor="middle">3</text>

    {#each Object.keys(data_heating) as city}
      {#if city == "Chicago"}
        {#each data_heating[city] as val, idx}
          <path d={Circle(cx=100, cy=100, r=scaleH(val), start_degree=scaleD(idx), stop_degree=scaleD(idx)+1)} fill="red" opacity="0.8"/>
        {/each}
      {:else if city == "Baltimore"}
      <g transform="translate(200, 0)">
        {#each data_heating[city] as val, idx}
          <path d={Circle(cx=100, cy=100, r=scaleH(val), start_degree=scaleD(idx), stop_degree=scaleD(idx)+0.5)} fill="red" opacity="0.8"/>
        {/each}
      </g>
      {:else}
      <g transform="translate(400, 0)">
        {#each data_heating[city] as val, idx}
          <path d={Circle(cx=100, cy=100, r=scaleH(val), start_degree=scaleD(idx), stop_degree=scaleD(idx)+0.5)} fill="red" opacity="0.8"/>
        {/each}
      </g>
      {/if}
    {/each}

    {#each Object.keys(data_cooling) as city}
    {#if city == "Chicago"}
      {#each data_cooling[city] as val, idx}
        <path d={Circle(cx=100, cy=100, r=scaleC(val), start_degree=scaleD(idx), stop_degree=scaleD(idx)+1)} fill="blue" opacity="0.5"/>
      {/each}
    {:else if city == "Baltimore"}
    <g transform="translate(200, 0)">
      {#each data_cooling[city] as val, idx}
        <path d={Circle(cx=100, cy=100, r=scaleC(val), start_degree=scaleD(idx), stop_degree=scaleD(idx)+0.5)} fill="blue" opacity="0.5"/>
      {/each}
    </g>
    {:else}
    <g transform="translate(400, 0)">
      {#each data_cooling[city] as val, idx}
        <path d={Circle(cx=100, cy=100, r=scaleC(val), start_degree=scaleD(idx), stop_degree=scaleD(idx)+0.5)} fill="blue" opacity="0.5"/>
      {/each}
    </g>
    {/if}
  {/each}
  </g>
</svg>

<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
  line {
    stroke: black;
  }
</style>
